from .classes import Tape
from .errors import ScriptExecutionError, SyntaxError
from .functions import (
    run_script,
    run_tape,
    run_auth_script,
    add_opcode,
    add_contract,
    remove_contract,
    add_contract_interface,
    remove_contract_interface,
    bytes_to_int,
    int_to_bytes,
    uint_to_bytes,
    bytes_to_bool,
    bytes_to_float,
    float_to_bytes,
    clamp_scalar,
    derive_key_from_seed,
    derive_point_from_scalar,
    aggregate_points,
    aggregate_scalars,
    xor,
    bytes_are_same,
)
from .interfaces import CanCheckTransfer
from .parsing import (
    compile_script,
    decompile_script,
    add_opcode_parsing_handlers
)
from .tools import (
    create_merklized_script,
    generate_docs,
    add_soft_fork,
    make_adapter_lock_pub,
    make_adapter_lock_prv,
    make_single_sig_lock,
    make_single_sig_lock2,
    make_single_sig_witness,
    make_single_sig_witness2,
    make_multisig_lock,
    make_adapter_locks_pub,
    make_adapter_decrypt,
    decrypt_adapter,
    make_adapter_locks_prv,
    make_adapter_witness,
    make_delegate_key_lock,
    make_delegate_key_cert_sig,
    make_delegate_key_unlock,
    make_htlc_sha256_lock,
    make_htlc_shake256_lock,
    make_htlc_witness,
    make_htlc2_sha256_lock,
    make_htlc2_shake256_lock,
    make_htlc2_witness,
    make_ptlc_lock,
    make_ptlc_witness,
    make_ptlc_refund_witness,
    setup_amhl,
    release_left_amhl_lock,
)